﻿package  tv.snorkl.utils.bitmap {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.DisplayObject;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	import tv.snorkl.utils.bitmap.BitmapTile;
	
	public class BitmapTileGrid extends Sprite{
		
		private var _rows:int;
		private var _cols:int;
		private var _tileWidth:int;
		private var _tileHeight:int;
		private var _bmdSource:BitmapData;
		private var _image:DisplayObject;
		
		private var _tilesArray2D:Array;
		private var _tilesArray:Array;
		
		


		public function BitmapTileGrid(image:DisplayObject, cols:int, rows:int) {
			
			//note* add some stuff to validate params.
			
			_image = image;
			_rows = rows;
			_cols = cols;
			
			_tilesArray2D = [];
			
			_tilesArray = [];
			
			var ID:Number = 0;
			
			_bmdSource = new BitmapData(_image.width, image.height,true);
			_bmdSource.draw(_image);
			
			_tileWidth = _image.width / _cols;
			_tileHeight = _image.height / _rows;
			trace("tileWidth = " + _tileWidth);
			trace("tileHeight = " + _tileHeight);
			
			
			
			for (var r:Number=0; r<_rows; r++) {
				
				_tilesArray2D.push([]);
				
				for (var c:Number=0; c<_cols; c++) {
					//trace(c);
					
					

					var bmdCopy:BitmapData = new BitmapData(_tileWidth,_tileHeight, true);




					var left:Number = c * _tileWidth;
					var top:Number = r * _tileHeight;
					var right:Number = left + _tileWidth;
					var bottom:Number = top + _tileHeight;
					//trace("L:"+left + " T:"+top + " r:"+right + " b:"+bottom);
					var rect:Rectangle = new Rectangle(left,top,right,bottom);
					var pt:Point = new Point(0,0);

					bmdCopy.copyPixels(_bmdSource, rect, pt);


					var bm:Bitmap = new Bitmap(bmdCopy);
					
					
					var bitmapTile:BitmapTile = new BitmapTile(bm, left, top);
					 
					
					bitmapTile.x = bitmapTile.originX;
					bitmapTile.y = bitmapTile.originY;
					
					
					addChild(bitmapTile);
					
					_tilesArray2D[r][c] = bitmapTile;
					_tilesArray.push( bitmapTile);
					
					
				}
			}
			
			
	
			
		}
		
		
		public function get tilesArray():Array{
			return _tilesArray;
			}
			
		public function get tileWidth():Number{
			return _tileWidth;
			}	
			
		public function get tileHeight():Number{
			return _tileHeight;
			}	

	}
	
}
